- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# DL_DecryptorBase< T > Class Template Reference

`#include <pubkey.h>`

Inheritance diagram for DL_DecryptorBase< T >:

List of all members.

## Detailed Description

### template<class T>
class DL_DecryptorBase< T >

_

Definition at line 1179 of file pubkey.h.

## Public Types
typedef T | Element
## Public Member Functions
DecodingResult | Decrypt (RandomNumberGenerator &rng, const byte *ciphertext, size_t ciphertextLength, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a byte string, and return the length of plaintext
size_t | MaxPlaintextLength (size_t ciphertextLength) const
| maximum length of plaintext for a given ciphertext length
size_t | CiphertextLength (size_t plaintextLength) const
| calculate length of ciphertext given length of plaintext
bool | ParameterSupported (const char *name) const
| this object supports the use of the parameter with the given name
virtual BufferedTransformation * | CreateDecryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new decryption filter
DecodingResult | FixedLengthDecrypt (RandomNumberGenerator &rng, const byte *ciphertext, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a fixed size ciphertext
virtual size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
virtual size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual PrivateKey & | AccessPrivateKey ()=0
virtual const PrivateKey & | GetPrivateKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Protected Types
typedef DL_PrivateKey< T > | KeyInterface
## Protected Member Functions
virtual const DL_KeyAgreementAlgorithm< Element > & | GetKeyAgreementAlgorithm () const=0
virtual const DL_KeyDerivationAlgorithm< Element > & | GetKeyDerivationAlgorithm () const=0
virtual const DL_SymmetricEncryptionAlgorithm & | GetSymmetricEncryptionAlgorithm () const=0
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
virtual KeyInterface & | AccessKeyInterface ()=0
virtual const KeyInterface & | GetKeyInterface () const=0

## Member Function Documentation

template<class T>

DecodingResult DL_DecryptorBase< T >::Decrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | ciphertext,
|  | size_t | ciphertextLength,
|  | byte * | plaintext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs` |
| ) |  |  | const`[inline, virtual]`

decrypt a byte string, and return the length of plaintext

Precondition:
  size of plaintext == MaxPlaintextLength(ciphertextLength) bytes.

Returns:
  the actual length of the plaintext, indication that decryption failed.

Implements PK_Decryptor.

Definition at line 1184 of file pubkey.h.

size_t DL_CryptoSystemBase< PK_Decryptor , DL_PrivateKey< T > >::MaxPlaintextLength | ( | size_t | ciphertextLength | ) | const`[inline, virtual, inherited]`

Implements PK_CryptoSystem.

Definition at line 1156 of file pubkey.h.

size_t DL_CryptoSystemBase< PK_Decryptor , DL_PrivateKey< T > >::CiphertextLength | ( | size_t | plaintextLength | ) | const`[inline, virtual, inherited]`

Implements PK_CryptoSystem.

Definition at line 1162 of file pubkey.h.

bool DL_CryptoSystemBase< PK_Decryptor , DL_PrivateKey< T > >::ParameterSupported | ( | const char * | name | ) | const`[inline, virtual, inherited]`

Implements PK_CryptoSystem.

Definition at line 1168 of file pubkey.h.

BufferedTransformation * PK_Decryptor::CreateDecryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs` |
| ) |  |  | const`[virtual, inherited]`

create a new decryption filter

Note:
  caller is responsible for deleting the returned pointer

Definition at line 644 of file cryptlib.cpp.

virtual size_t PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const`[inline, virtual, inherited]`

return fixed ciphertext length, if one exists, otherwise return 0

Note:
  "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length.

Reimplemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, and TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >.

Definition at line 1165 of file cryptlib.h.

Referenced by PK_Decryptor::FixedLengthDecrypt().

The documentation for this class was generated from the following file:

- pubkey.h